// Code generated by go-swagger; DO NOT EDIT.

package outgoing_webhook

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/pear-slices/mobile_platform/bitrise-step-api-build-trigger/models"
)

// NewOutgoingWebhookCreateParams creates a new OutgoingWebhookCreateParams object
// with the default values initialized.
func NewOutgoingWebhookCreateParams() *OutgoingWebhookCreateParams {
	var ()
	return &OutgoingWebhookCreateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewOutgoingWebhookCreateParamsWithTimeout creates a new OutgoingWebhookCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewOutgoingWebhookCreateParamsWithTimeout(timeout time.Duration) *OutgoingWebhookCreateParams {
	var ()
	return &OutgoingWebhookCreateParams{

		timeout: timeout,
	}
}

// NewOutgoingWebhookCreateParamsWithContext creates a new OutgoingWebhookCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewOutgoingWebhookCreateParamsWithContext(ctx context.Context) *OutgoingWebhookCreateParams {
	var ()
	return &OutgoingWebhookCreateParams{

		Context: ctx,
	}
}

// NewOutgoingWebhookCreateParamsWithHTTPClient creates a new OutgoingWebhookCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewOutgoingWebhookCreateParamsWithHTTPClient(client *http.Client) *OutgoingWebhookCreateParams {
	var ()
	return &OutgoingWebhookCreateParams{
		HTTPClient: client,
	}
}

/*OutgoingWebhookCreateParams contains all the parameters to send to the API endpoint
for the outgoing webhook create operation typically these are written to a http.Request
*/
type OutgoingWebhookCreateParams struct {

	/*AppSlug
	  App slug

	*/
	AppSlug string
	/*AppWebhookCreateParams
	  App webhook creation params

	*/
	AppWebhookCreateParams *models.V0AppWebhookCreateParams

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) WithTimeout(timeout time.Duration) *OutgoingWebhookCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) WithContext(ctx context.Context) *OutgoingWebhookCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) WithHTTPClient(client *http.Client) *OutgoingWebhookCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppSlug adds the appSlug to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) WithAppSlug(appSlug string) *OutgoingWebhookCreateParams {
	o.SetAppSlug(appSlug)
	return o
}

// SetAppSlug adds the appSlug to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) SetAppSlug(appSlug string) {
	o.AppSlug = appSlug
}

// WithAppWebhookCreateParams adds the appWebhookCreateParams to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) WithAppWebhookCreateParams(appWebhookCreateParams *models.V0AppWebhookCreateParams) *OutgoingWebhookCreateParams {
	o.SetAppWebhookCreateParams(appWebhookCreateParams)
	return o
}

// SetAppWebhookCreateParams adds the appWebhookCreateParams to the outgoing webhook create params
func (o *OutgoingWebhookCreateParams) SetAppWebhookCreateParams(appWebhookCreateParams *models.V0AppWebhookCreateParams) {
	o.AppWebhookCreateParams = appWebhookCreateParams
}

// WriteToRequest writes these params to a swagger request
func (o *OutgoingWebhookCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app-slug
	if err := r.SetPathParam("app-slug", o.AppSlug); err != nil {
		return err
	}

	if o.AppWebhookCreateParams != nil {
		if err := r.SetBodyParam(o.AppWebhookCreateParams); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
